/*
 * File: app/view/Game.js
 *
 * This file was generated by Sencha Architect version 2.1.0.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Sencha Touch 2.0.x library, under independent license.
 * License of Sencha Architect does not include license for Sencha Touch 2.0.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('IdiomesApp.view.Game', {
    extend: 'Ext.Container',

    config: {
        id: 'game',
        style: 'background-color: #ccc;',
        items: [
            {
                xtype: 'carousel',
                docked: 'top',
                height: 200,
                id: 'carruselParaules',
                itemId: 'carruselParaules',
                items: [
                    {
                        xtype: 'container',
                        border: 1,
                        cls: [
                            'card1'
                        ],
                        height: 200,
                        html: '',
                        id: 'pregunta',
                        tpl: [
                            '<div>',
                            '    <h3>Quin és el símbol Kanji de la següent paraula?</h3>',
                            '    <h1>{textcat}</h1>',
                            '    <p>(Desplaça la targeta per veure la resposta)</p>',
                            '</div>'
                        ],
                        ui: '',
                        layout: {
                            type: 'fit'
                        },
                        scrollable: false
                    },
                    {
                        xtype: 'container',
                        border: 1,
                        cls: [
                            'card1'
                        ],
                        height: 200,
                        id: 'resposta',
                        tpl: [
                            '<div>',
                            '    <h2>{textjap}</h2>',
                            '    <p>{pronjap}</p>',
                            '</div>'
                        ],
                        ui: '',
                        layout: {
                            type: 'fit'
                        }
                    }
                ]
            },
            {
                xtype: 'container',
                docked: 'bottom',
                ui: 'light',
                layout: {
                    type: 'fit'
                },
                items: [
                    {
                        xtype: 'toolbar',
                        docked: 'bottom',
                        ui: 'light',
                        title: '',
                        layout: {
                            align: 'center',
                            pack: 'center',
                            type: 'hbox'
                        },
                        items: [
                            {
                                xtype: 'button',
                                disabled: true,
                                id: 'pendents',
                                itemId: 'mybutton13',
                                iconCls: 'time',
                                iconMask: true,
                                text: 'Pendents',
                                listeners: [
                                    {
                                        fn: function(component, options) {
                                            Ext.getCmp('pendents').setBadgeText(IdiomesApp.numPendents);
                                        },
                                        event: 'initialize'
                                    }
                                ]
                            },
                            {
                                xtype: 'button',
                                disabled: true,
                                id: 'encerts',
                                itemId: 'mybutton14',
                                badgeText: '0',
                                iconAlign: 'right',
                                iconCls: 'star',
                                iconMask: true,
                                text: 'Encerts'
                            }
                        ]
                    }
                ]
            },
            {
                xtype: 'label',
                centered: true,
                hidden: true,
                html: '<p>Has encertat?</p>',
                id: 'hasencertat'
            },
            {
                xtype: 'button',
                height: 50,
                hidden: true,
                id: 'fallada',
                itemId: 'mybutton2',
                left: 15,
                top: 230,
                ui: 'decline-round',
                iconCls: 'delete',
                iconMask: true,
                text: 'No'
            },
            {
                xtype: 'button',
                height: 50,
                hidden: true,
                id: 'encert',
                itemId: 'mybutton1',
                right: 15,
                top: 230,
                ui: 'confirm-round',
                iconAlign: 'right',
                iconCls: 'favorites',
                iconMask: true,
                text: 'Sí'
            }
        ],
        listeners: [
            {
                fn: 'onCarruselParaulesActiveItemChange',
                event: 'activeitemchange',
                delegate: '#carruselParaules'
            },
            {
                fn: 'onFalladaTap',
                event: 'tap',
                delegate: '#fallada'
            },
            {
                fn: 'onEncertTap',
                event: 'tap',
                delegate: '#encert'
            }
        ]
    },

    onCarruselParaulesActiveItemChange: function(container, value, oldValue, options) {
        if(value.config.id == 'pregunta'){
            Ext.getCmp('hasencertat').setHidden(true);
            Ext.getCmp('fallada').setHidden(true);
            Ext.getCmp('encert').setHidden(true);
        }else{
            Ext.getCmp('hasencertat').setHidden(false);
            Ext.getCmp('fallada').setHidden(false);
            Ext.getCmp('encert').setHidden(false);
        }
    },

    onFalladaTap: function(button, e, options) {
        var carrusel = Ext.getCmp('carruselParaules');

        if (carrusel) {
            Ext.getCmp('game').destroy();
        }

        //console.log(record.get('id'));
        Ext.getCmp('flashcards').setActiveItem({
            xclass: 'IdiomesApp.view.Game'
        });

        Ext.getCmp('encerts').setBadgeText(IdiomesApp.numEncerts);
        Ext.getCmp('pendents').setBadgeText(IdiomesApp.numPendents);

        //Obtenim la següent paraula de l'exercici
        Ext.Ajax.request({
            url: 'http://eduardcapell.com/pfc2012/get_paraula',
            params: {
                llista: IdiomesApp.llistaFlashcards
            },
            success: function(response, opts){
                var obj = Ext.decode(response.responseText);
                if(obj.success !== true){
                    //console.log(obj);
                    //console.log(obj.errorMessage);
                    Ext.Msg.alert("Informació", obj.errorMessage);
                }else{
                    //Enviam la paraula obtinguda al carrusel de l'exercici
                    //console.log("*** SEGÜENT PARAULA ***");
                    //console.log(obj.koncept);
                    //console.log(record);

                    //Construïm una plantilla (template) pel contenidor de l'exercici
                    var tplPregunta = new Ext.XTemplate(
                    '<div>',
                    '<h3>Quin és el símbol Kanji de la següent paraula?</h3>',
                    '<h1>' + obj.koncept.textcat + '</h1>',
                    '<p>(Desplaça la targeta per veure la resposta)</p>',
                    '</div>'
                    );
                    var tplResposta = new Ext.XTemplate(
                    '<div>',
                    '<h2>' + obj.koncept.textjap + '</h2>',
                    '<p>' + obj.koncept.pronjap + '</p>',
                    '</div>'
                    );
                    //console.log(tplPregunta);
                    //console.log(tplResposta);
                    Ext.getCmp('pregunta').setTpl(tplPregunta);
                    Ext.getCmp('resposta').setTpl(tplResposta);
                    Ext.getCmp('pregunta').setRecord(IdiomesApp.registre);
                    Ext.getCmp('resposta').setRecord(IdiomesApp.registre);
                }
            },
            failure: function(response){
                console.log('server-side failure with status code: ' + response.status);
                Ext.Msg.alert("No és possible obtenir una paraula de la llista");
            }
        });

        //Torna a la cara A (pregunta) de la targeta
        Ext.getCmp('carruselParaules').previous();
    },

    onEncertTap: function(button, e, options) {
        if(IdiomesApp.numPendents === 1){
            Ext.Msg.alert('Felicitats','Ho has fet molt bé!');
            Ext.getCmp('game').destroy();
            IdiomesApp.titol="Seleccioni una Llista d\'Estudi";
            Ext.getCmp('listPanel3').setHidden(false);
            //Ext.getCmp('novaLlista').setHidden(true);
            Ext.getCmp('novaParaula').setHidden(true);

            Ext.getCmp('enrere').setHidden(true);
            Ext.getCmp('nouJoc').setHidden(true);
            Ext.getCmp('myToolBar').setTitle(IdiomesApp.titol);
        }else{
            //console.log("OK");

            var carrusel = Ext.getCmp('carruselParaules');

            if (carrusel) {
                Ext.getCmp('game').destroy();
            }

            //console.log(record.get('id'));
            Ext.getCmp('flashcards').setActiveItem({
                xclass: 'IdiomesApp.view.Game'
            });

            //Actualitzam els comptadors de targetes pendents i targetes encertades
            IdiomesApp.numEncerts = parseInt(IdiomesApp.numEncerts)+parseInt(1);
            IdiomesApp.numPendents = parseInt(IdiomesApp.numPendents)-parseInt(1);
            //Incrementa el comptador de targetes (paraules de la llista d'estudi) encertades
            Ext.getCmp('encerts').setBadgeText(IdiomesApp.numEncerts);
            //Decreix el nombre de targetes (paraules de la llista d'estudi) pendents de resoldre
            Ext.getCmp('pendents').setBadgeText(IdiomesApp.numPendents);

            //Obtenim la següent paraula de l'exercici
            Ext.Ajax.request({
                url: 'http://eduardcapell.com/pfc2012/get_paraula',
                params: {
                    llista: IdiomesApp.llistaFlashcards
                },
                success: function(response, opts){
                    var obj = Ext.decode(response.responseText);
                    if(obj.success !== true){
                        //console.log(obj);
                        //console.log(obj.errorMessage);
                        Ext.Msg.alert("Informació", obj.errorMessage);
                    }else{
                        //Enviam la paraula obtinguda al carrusel de l'exercici
                        //console.log("*** SEGÜENT PARAULA ***");
                        //console.log(obj.koncept);
                        //console.log(record);

                        //Construïm una plantilla (template) pel contenidor de l'exercici
                        var tplPregunta = new Ext.XTemplate(
                        '<div>',
                        '<h3>Quin és el símbol Kanji de la següent paraula?</h3>',
                        '<h1>' + obj.koncept.textcat + '</h1>',
                        '<p>(Desplaça la targeta per veure la resposta)</p>',
                        '</div>'
                        );
                        var tplResposta = new Ext.XTemplate(
                        '<div>',
                        '<h2>' + obj.koncept.textjap + '</h2>',
                        '<p>' + obj.koncept.pronjap + '</p>',
                        '</div>'
                        );
                        //console.log(tplPregunta);
                        //console.log(tplResposta);
                        Ext.getCmp('pregunta').setTpl(tplPregunta);
                        Ext.getCmp('resposta').setTpl(tplResposta);
                        Ext.getCmp('pregunta').setRecord(IdiomesApp.registre);
                        Ext.getCmp('resposta').setRecord(IdiomesApp.registre);
                    }
                },
                failure: function(response){
                    console.log('server-side failure with status code: ' + response.status);
                    Ext.Msg.alert("No és possible obtenir una paraula de la llista");
                }
            });
            //Mostram la pregunta nova de la targeta
            Ext.getCmp('carruselParaules').previous();
        }
    }

});