/*
 * File: app/view/addParaula.js
 *
 * This file was generated by Sencha Architect version 2.1.0.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Sencha Touch 2.0.x library, under independent license.
 * License of Sencha Architect does not include license for Sencha Touch 2.0.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('IdiomesApp.view.addParaula', {
    extend: 'Ext.form.Panel',
    alias: 'widget.addparaula',

    config: {
        id: 'addParaula',
        itemId: 'addParaula',
        layout: {
            pack: 'center',
            type: 'vbox'
        },
        scrollable: 'vertical',
        items: [
            {
                xtype: 'fieldset',
                id: 'formParaula',
                itemId: 'fieldsetparaula',
                title: 'Nova paraula',
                items: [
                    {
                        xtype: 'textfield',
                        id: 'text_catala',
                        label: 'Català',
                        name: 'text_catala',
                        required: true,
                        autoCapitalize: true,
                        placeHolder: 'Texte en català de la nova paraula'
                    },
                    {
                        xtype: 'textfield',
                        id: 'text_japones',
                        label: 'Kanji',
                        name: 'text_japones',
                        required: true,
                        placeHolder: 'Símbol Kanji de la nova paraula'
                    },
                    {
                        xtype: 'textfield',
                        id: 'pron_japones',
                        label: 'Pronunciació (kun\'yomi)',
                        name: 'pron_japones',
                        required: true,
                        placeHolder: 'Pronunciació en japonès (kun\'yomi) de la nova paraula'
                    },
                    {
                        xtype: 'selectfield',
                        id: 'llista_estudi',
                        itemId: 'llista_estudi',
                        label: 'Llista',
                        name: 'llista_estudi',
                        placeHolder: 'Abans ha de tenir llistes d\'estudi creades',
                        displayField: 'nom',
                        store: 'llistaJson',
                        valueField: 'id'
                    }
                ]
            },
            {
                xtype: 'button',
                itemId: 'submit',
                ui: 'confirm',
                iconCls: 'add',
                iconMask: true,
                text: 'Guardar'
            }
        ],
        listeners: [
            {
                fn: 'onSubmitTap',
                event: 'tap',
                delegate: '#submit'
            }
        ]
    },

    onSubmitTap: function(button, e, options) {
        var form = Ext.getCmp('addParaula'),
            store = Ext.getCmp('paraulesList').getStore(),
            paraulaRecord = form.getValues();

        if (paraulaRecord.text_catala!=="" & paraulaRecord.text_japones!=="" & paraulaRecord.pron_japones!=="" & paraulaRecord.idLlista!==null){

            //SLORCA: comentam aquestes línies perquè estam usant un manejat que realitza
            //la petició de guardar al servidor
            //Nou registre en l'emmagatzematge local
            //paraulaRecord.id=IdiomesApp.idNovaParaula;
            //store.add(paraulaRecord);

            console.log(paraulaRecord);

            Ext.Ajax.request({
                method: 'POST',
                url: 'http://eduardcapell.com/pfc2012/crear_concepte_paraula',
                params:{
                    text_catala: paraulaRecord.text_catala,
                    text_japones: paraulaRecord.text_japones,
                    pronjap: paraulaRecord.pron_japones,
                    llista: paraulaRecord.llista_estudi
                },
                success: function(response, opts){
                    var obj = Ext.decode(response.responseText);
                    if(obj.success !== true){
                        //console.log(obj);
                        //console.log(obj.errorMessage);
                        Ext.Msg.alert("Error", obj.errorMessage);
                    }else{
                        Ext.Msg.alert("Informació","Paraula guardada correctament");
                    }
                },
                failure: function(response){
                    console.log('server-side failure with status code: ' + response.status);
                    Ext.Msg.alert("No és possible guardar la paraula al diccionari");
                }
            });


            form.reset();
            Ext.getCmp('paraulesList').deselectAll();
            IdiomesApp.titol=IdiomesApp.titolAux;
            Ext.getCmp('enrere').setHidden(true);
            Ext.getCmp('listPanel').setHidden(false);
            Ext.getCmp('diccionari').remove(form,true);
            //Carrega de nou la petició de la llista per refrescar els elements
            Ext.getStore('paraulaJson').load();
            Ext.getCmp('novaParaula').setHidden(false);
            Ext.getCmp('myToolBar').setTitle(IdiomesApp.titol);
            Ext.getCmp('diccionari').removeAt(1);

        }else{

            Ext.Msg.alert('Error',"Tots els camps són obligatoris");

        }
    }

});