/*
 * File: app/view/editParaula.js
 *
 * This file was generated by Sencha Architect version 2.1.0.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Sencha Touch 2.0.x library, under independent license.
 * License of Sencha Architect does not include license for Sencha Touch 2.0.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('IdiomesApp.view.editParaula', {
    extend: 'Ext.form.Panel',
    alias: 'widget.editParaula',

    config: {
        id: 'editParaula',
        itemId: 'editParaula',
        layout: {
            pack: 'center',
            type: 'vbox'
        },
        scrollable: 'vertical',
        items: [
            {
                xtype: 'fieldset',
                id: 'formParaulaEdit',
                itemId: 'fieldsetparaulaedit',
                title: 'Edició de paraula',
                items: [
                    {
                        xtype: 'textfield',
                        id: 'textCatEdit',
                        itemId: 'textCatEdit',
                        label: 'Català',
                        name: 'textcat',
                        required: true,
                        autoCapitalize: true,
                        placeHolder: 'Texte en català de la paraula'
                    },
                    {
                        xtype: 'textfield',
                        id: 'textJapEdit',
                        itemId: 'textJapEdit',
                        label: 'Kanji',
                        name: 'textjap',
                        required: true,
                        placeHolder: 'Símbol Kanji de la paraula'
                    },
                    {
                        xtype: 'textfield',
                        id: 'pronJapEdit',
                        itemId: 'pronJapEdit',
                        label: 'Pronunciació',
                        name: 'pronjap',
                        required: true,
                        placeHolder: 'Pronunciació en japonès de la paraula'
                    },
                    {
                        xtype: 'selectfield',
                        id: 'llistaEdit',
                        itemId: 'llistaEdit',
                        label: 'Llista',
                        name: 'idLlista',
                        placeHolder: 'Abans ha de tenir llistes d\'estudi creades',
                        displayField: 'nom',
                        store: 'llistaJson',
                        valueField: 'id'
                    },
                    {
                        xtype: 'hiddenfield',
                        id: 'idEdit',
                        name: 'id'
                    }
                ],
                listeners: [
                    {
                        fn: function(component, options) {
                            var rec = Ext.create('IdiomesApp.model.paraulaModel', {
                                id: IdiomesApp.paraula,
                                textcat: IdiomesApp.paraulaTextCat,
                                textjap: IdiomesApp.paraulaTextJap,
                                pronjap: IdiomesApp.paraulaPronJap,
                                idLlista: IdiomesApp.paraulaLlista
                            });

                            /*console.log(IdiomesApp.paraula);
                            console.log("*** " + IdiomesApp.paraulaLlista + " ***");
                            console.log(IdiomesApp.paraulaTextCat);*/

                            //console.log(Ext.getCmp('editParaula'));

                            //No funciona
                            //Ext.getCmp('editParaula').setRecord(rec);

                            //Carregam les dades:
                            Ext.getCmp('idEdit').setValue(rec.get('id'));
                            Ext.getCmp('textCatEdit').setValue(rec.get('textcat'));
                            Ext.getCmp('textJapEdit').setValue(rec.get('textjap'));
                            Ext.getCmp('pronJapEdit').setValue(rec.get('pronjap'));
                            Ext.getCmp('llistaEdit').setValue(rec.get('idLlista'));
                        },
                        event: 'initialize'
                    }
                ]
            },
            {
                xtype: 'button',
                itemId: 'submit',
                ui: 'action',
                iconMask: true,
                text: 'Editar'
            }
        ],
        listeners: [
            {
                fn: 'onSubmitTap',
                event: 'tap',
                delegate: '#submit'
            }
        ]
    },

    onSubmitTap: function(button, e, options) {
        var form = Ext.getCmp('editParaula'),
            store = Ext.getCmp('paraulesList').getStore(),
            paraulaEditRecord = form.getValues();

        if (paraulaEditRecord.textcat!=="" & paraulaEditRecord.textjap!=="" & paraulaEditRecord.pronjap!==""  & paraulaEditRecord.idLlista!==null){

            Ext.Ajax.request({
                method: 'POST',
                url: 'http://eduardcapell.com/pfc2012/editar_camp_concepte_paraula',
                params:{
                    id: paraulaEditRecord.id,
                    text_catala: paraulaEditRecord.textcat,
                    text_japones: paraulaEditRecord.textjap,
                    pronjap: paraulaEditRecord.pronjap,
                    llista: paraulaEditRecord.idLlista
                },
                success: function(response, opts){
                    var obj = Ext.decode(response.responseText);
                    if(obj.success !== true){
                        //console.log(obj);
                        //console.log(obj.errorMessage);
                        Ext.Msg.alert("Error", obj.errorMessage);
                    }else{
                        Ext.Msg.alert("Informació","Paraula editada correctament");
                    }
                },
                failure: function(response){
                    console.log('server-side failure with status code: ' + response.status);
                    Ext.Msg.alert("No és possible editar la paraula del diccionari");
                }
            });


            form.reset();
            Ext.getCmp('paraulesList').deselectAll();
            IdiomesApp.titol=IdiomesApp.titolAux;
            Ext.getCmp('enrere').setHidden(true);
            Ext.getCmp('listPanel').setHidden(false);
            Ext.getCmp('diccionari').remove(form,true);
            Ext.getCmp('diccionari').remove(Ext.getCmp('DetallParaula'),true);
            //Carrega de nou la petició de la llista per refrescar els elements
            Ext.getStore('paraulaJson').load();
            Ext.getCmp('novaParaula').setHidden(false);
            Ext.getCmp('myToolBar').setTitle(IdiomesApp.titol);
            Ext.getCmp('diccionari').removeAt(1);

        }else{

            Ext.Msg.alert('Error',"Tots els camps són obligatoris");

        }
    }

});