/*
 * File: app/view/menuPanel.js
 *
 * This file was generated by Sencha Architect version 2.1.0.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Sencha Touch 2.0.x library, under independent license.
 * License of Sencha Architect does not include license for Sencha Touch 2.0.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('IdiomesApp.view.menuPanel', {
    extend: 'Ext.tab.Panel',
    alias: 'widget.menupanel',

    requires: [
        'IdiomesApp.view.ListPanel',
        'IdiomesApp.view.ListPanel2',
        'IdiomesApp.view.ListPanel3'
    ],

    config: {
        id: 'menuPanel',
        ui: 'light',
        modal: false,
        tabBar: {
            docked: 'bottom',
            itemId: 'mytabbar',
            ui: 'light',
            layout: {
                pack: 'center',
                type: 'hbox'
            }
        },
        items: [
            {
                xtype: 'container',
                title: 'Diccionari',
                iconCls: 'bookmarks',
                id: 'diccionari',
                width: '100%',
                layout: {
                    type: 'fit'
                },
                items: [
                    {
                        xtype: 'listpanel',
                        itemId: 'listPanel',
                        width: '100%'
                    },
                    {
                        xtype: 'panel',
                        hidden: true,
                        html: 'Comenci per donar d\'alta noves paraules',
                        id: 'avisDiccionariBuit',
                        padding: 10,
                        right: 0,
                        top: 15
                    }
                ]
            },
            {
                xtype: 'container',
                title: 'Llistes d\'estudi',
                iconCls: 'favorites',
                id: 'llistesdestudi',
                width: '100%',
                layout: {
                    type: 'fit'
                },
                items: [
                    {
                        xtype: 'listpanel2',
                        itemId: 'listPanel2',
                        width: '100%'
                    }
                ]
            },
            {
                xtype: 'container',
                title: 'Flashcards',
                iconCls: 'organize',
                id: 'flashcards',
                width: '100%',
                layout: {
                    type: 'fit'
                },
                items: [
                    {
                        xtype: 'listpanel3'
                    }
                ]
            },
            {
                xtype: 'toolbar',
                docked: 'top',
                height: 35,
                id: 'myToolBar',
                itemId: 'myToolBar',
                style: 'font-size:10px;',
                ui: 'light',
                scrollable: false,
                title: 'Diccionari',
                items: [
                    {
                        xtype: 'button',
                        hidden: true,
                        id: 'enrere',
                        itemId: 'enrere',
                        style: 'font-size:16px;',
                        ui: 'back',
                        text: 'Enrere'
                    },
                    {
                        xtype: 'button',
                        docked: 'right',
                        hidden: true,
                        id: 'novaLlista',
                        itemId: 'mybutton1',
                        right: '5px',
                        style: '',
                        top: '5px',
                        ui: 'action-round',
                        iconAlign: 'center',
                        iconCls: 'add',
                        iconMask: true,
                        text: ''
                    },
                    {
                        xtype: 'button',
                        docked: 'right',
                        height: 22,
                        hidden: true,
                        id: 'editarParaula',
                        itemId: 'editarParaula',
                        right: '5px',
                        top: '5px',
                        ui: 'action-round',
                        iconCls: 'more',
                        iconMask: true,
                        text: ''
                    },
                    {
                        xtype: 'button',
                        hidden: true,
                        id: 'nouJoc',
                        itemId: 'mybutton10',
                        style: 'font-size:12px',
                        ui: 'confirm-round',
                        text: 'Nou joc'
                    },
                    {
                        xtype: 'button',
                        id: 'novaParaula',
                        itemId: 'novaParaula',
                        right: 5,
                        top: 5,
                        ui: 'confirm-round',
                        iconCls: 'add',
                        iconMask: true
                    }
                ]
            }
        ],
        listeners: [
            {
                fn: 'onNovaLlista',
                event: 'tap',
                delegate: '#novaLlista'
            },
            {
                fn: 'onEditarParaulaTap',
                event: 'tap',
                delegate: '#editarParaula'
            },
            {
                fn: 'onNouJocTap',
                event: 'tap',
                delegate: '#nouJoc'
            },
            {
                fn: 'onNovaParaulaTap',
                event: 'tap',
                delegate: '#novaParaula'
            },
            {
                fn: 'onMenuPanelActiveItemChange',
                event: 'activeitemchange'
            }
        ]
    },

    onNovaLlista: function(button, e, options) {
        Ext.getCmp('novaLlista').setHidden(true);
        Ext.getCmp('listPanel2').setHidden(true);
        Ext.getCmp('enrere').setHidden(false);
        IdiomesApp.titolAux=IdiomesApp.titol;
        IdiomesApp.titol="Nova llista d'estudi";
        Ext.getCmp('myToolBar').setTitle(IdiomesApp.titol);

        Ext.getCmp('llistesdestudi').setActiveItem({
            xclass: 'IdiomesApp.view.addLlista'
        });
    },

    onEditarParaulaTap: function(button, e, options) {
        Ext.getCmp('novaParaula').setHidden(true);
        Ext.getCmp('editarParaula').setHidden(false);
        Ext.getCmp('enrere').setHidden(false);

        var sheet = button.actionSheet;
        if (!sheet) {
            sheet = button.actionSheet = Ext.Viewport.add(Ext.widget('opcionsParaula'));
        }
        sheet.show();
    },

    onNouJocTap: function(button, e, options) {
        //Ext.getCmp('carruselParaules').destroy();

        //Posam a 0 el comptador del servidor de les paraules que hagin aparegut a l'exercici de Flashcards
        Ext.Ajax.request({
            method: 'POST',
            url: 'http://eduardcapell.com/pfc2012/reset_game',
            success: function(response, opts){
                var obj = Ext.decode(response.responseText);
                if(obj.success !== true){
                    console.log(obj);
                    console.log(obj.errorMessage);
                }
            },
            failure: function(response){
                console.log('server-side failure with status code: ' + response.status);
            }
        });

        //Mostram el llistat de Llistes d'Estudi a l'usuari per a una nova selecció
        Ext.getCmp('game').destroy();
        IdiomesApp.titol="Seleccioni una Llista d\'Estudi";
        Ext.getCmp('listPanel3').setHidden(false);
        Ext.getCmp('novaLlista').setHidden(true);
        Ext.getCmp('novaParaula').setHidden(true);

        Ext.getCmp('enrere').setHidden(true);
        Ext.getCmp('nouJoc').setHidden(true);
        Ext.getCmp('myToolBar').setTitle(IdiomesApp.titol);
    },

    onNovaParaulaTap: function(button, e, options) {
        Ext.getCmp('novaParaula').setHidden(true);
        Ext.getCmp('listPanel').setHidden(true);
        Ext.getCmp('enrere').setHidden(false);
        IdiomesApp.titolAux=IdiomesApp.titol;
        IdiomesApp.titol="Nova paraula";
        Ext.getCmp('myToolBar').setTitle(IdiomesApp.titol);

        var formadd = Ext.getCmp('addParaula');

        if (formadd) {
            Ext.getCmp('addParaula').destroy();
        }

        Ext.getCmp('diccionari').setActiveItem({
            xclass: 'IdiomesApp.view.addParaula'
        });
    },

    onMenuPanelActiveItemChange: function(container, value, oldValue, options) {
        //Ext.Msg.alert('activeitemchange', 'Current tab: ' + value.config.id);
        IdiomesApp.titol=value.config.title;
        IdiomesApp.titolAux=value.config.title;

        //Secció nova
        if (value.config.id == 'diccionari'){
            if (Ext.getCmp('DetallParaula')){
                Ext.getCmp('DetallParaula').setHidden(true);
            }
            if (Ext.getCmp('addParaula')){
                Ext.getCmp('addParaula').setHidden(true);
            }
            if (Ext.getCmp('editParaula')){
                Ext.getCmp('editParaula').setHidden(true);
            }
            Ext.getCmp('listPanel').setHidden(false);
            //No es permeten donar d'alta noves llistes perquè van en funció d'un fitxer json local
            //Ext.getCmp('novaLlista').setHidden(true);
            Ext.getCmp('novaParaula').setHidden(false);
            //Carrega de nou la petició de la llista per refrescar els elements
            Ext.getStore('paraulaJson').load();
        }
        if (value.config.id == 'llistesdestudi'){
            Ext.getCmp('editarParaula').setHidden(true);
            Ext.getCmp('listPanel2').setHidden(false);
            Ext.getCmp('novaParaula').setHidden(true);
            //No es permeten donar d'alta noves llistes perquè van en funció d'un fitxer json local
            //Ext.getCmp('novaLlista').setHidden(false);
        }
        if (value.config.id == 'flashcards'){ 
            if (Ext.getCmp('game')){
                Ext.getCmp('game').setHidden(true);
            }
            Ext.getCmp('editarParaula').setHidden(true);
            IdiomesApp.titol="Seleccioni una Llista d\'Estudi";
            Ext.getCmp('listPanel3').setHidden(false);
            //No es permeten donar d'alta noves llistes perquè van en funció d'un fitxer json local
            //Ext.getCmp('novaLlista').setHidden(true);
            Ext.getCmp('novaParaula').setHidden(true);
        }

        Ext.getCmp('enrere').setHidden(true);
        Ext.getCmp('nouJoc').setHidden(true);
        Ext.getCmp('myToolBar').setTitle(IdiomesApp.titol);
    }

});